<script lang="ts">
import { computed, provide } from 'vue';
import { JTopRightKeyboardNavHint } from '../JKeyboardNavHint';
import useKeyboardNavigationFocus from './useKeyboardNavigationFocus';

export default {
  name: 'JKeyboardNavByFocus',
  components: {
    JTopRightKeyboardNavHint,
  },
  props: {
    reverse: {
      type: Boolean,
      default: false,
    },
  },
  setup(props) {
    const {
      keyboardNavContainer,
      focusOnNextElement,
      focusOnPrevElement,
      setInitialFocus,
    } = useKeyboardNavigationFocus(computed(() => props.reverse));

    provide('onArrowUp', focusOnPrevElement);
    provide('onArrowDown', focusOnNextElement);

    return {
      keyboardNavContainer,
      setInitialFocus,
    }
  },
};
</script>

<template>
  <div
    ref="keyboardNavContainer"
    class="j-keyboard-nav-by-focus"
    tabindex="0"
    @keydown.prevent.arrow-up="setInitialFocus"
    @keydown.prevent.arrow-down="setInitialFocus"
  >
    <slot />
    <JTopRightKeyboardNavHint
      v-once
      class="j-keyboard-hint"
    />
  </div>
</template>

<style scoped lang="scss">
.j-keyboard-nav-by-focus {
  position: relative;
  width: 100%;
  height: 100%;
  overflow: hidden;

  .j-keyboard-hint {
    display: none;
  }

  &:focus-visible {
    &::before {
      content: '';
      position: absolute;
      z-index: 10;
      pointer-events: none;
      width: 100%;
      height: 100%;
      box-shadow: var(--j-focus-shadow);
    }

    .j-keyboard-hint {
      display: flex;
    }
  }
}
</style>
